/*
 * 
 */
package com.mysema.commons.jetty;

import static com.mysema.commons.jetty.JettyHelper.runningAt;
import static com.mysema.commons.jetty.JettyHelper.startJetty;
import static com.mysema.commons.jetty.JettyHelper.stopJettyAtPort;

import org.junit.internal.runners.InitializationError;
import org.junit.internal.runners.JUnit4ClassRunner;
import org.junit.runner.notification.RunNotifier;

/**
 * JettyTestRunner provides.
 * 
 * @author Timo Westkamper
 * @version $Id$
 */
public class JettyTestRunner extends JUnit4ClassRunner {

    public JettyTestRunner(Class<?> klass) throws InitializationError {
        super(klass);
    }

    /*
     * (non-Javadoc)
     * 
     * @seeorg.junit.internal.runners.JUnit4ClassRunner#run(org.junit.runner.
     * notification.RunNotifier)
     */
    public void run(final RunNotifier notifier) {
        try {
            beforeTests();
            super.run(notifier);

        } finally {
            afterTests();
        }
    }

    private void beforeTests() {
        if (!runningAt(9080)) {
            try {
                startJetty("src/main/webapp", "/", 9080, 9443);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
    }

    private void afterTests() {
        try {
            stopJettyAtPort(9080);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
